Index: palm/trunk/SOURCE/radiation_model.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model.f90	(revision 1686)
+++ palm/trunk/SOURCE/radiation_model.f90	(revision 1691)
@@ -19,5 +19,7 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added option for spin-up runs without radiation (skip_time_do_radiation). Bugfix
+! in calculation of pressure profiles. Bugfix in calculation of trace gas profiles.
+! Added output of radiative heating rates.
 ! 
 ! Former revisions:
@@ -61,5 +63,4 @@
 !> @todo Output of other rrtm arrays (such as volume mixing ratios)
 !> @todo Adapt for use with topography
-!> @todo Remove 3D dummy arrays (such as clear-sky output)
 !>
 !> @note Many variables have a leading dummy dimension (0:0) in order to
@@ -70,8 +71,8 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  hyp, pt, q, ql, zw
+        ONLY:  dzw, hyp, pt, q, ql, zw
 
     USE cloud_parameters,                                                      &
-        ONLY:  cp, l_v, nc_const, rho_l, sigma_gc  
+        ONLY:  cp, l_d_cp, nc_const, rho_l, sigma_gc  
 
     USE constants,                                                             &
@@ -80,5 +81,5 @@
     USE control_parameters,                                                    &
         ONLY:  cloud_droplets, cloud_physics, g, initializing_actions,         &
-               large_scale_forcing, lsf_surf, phi, pt_surface,                 &
+               large_scale_forcing, lsf_surf, phi, pt_surface, rho_surface,    &
                surface_pressure, time_since_reference_point
 
@@ -153,33 +154,36 @@
 
 
-    LOGICAL ::  constant_albedo = .FALSE., & !< flag parameter indicating whether the albedo may change depending on zenith
-                lw_radiation = .TRUE.,     & !< flag parameter indicing whether longwave radiation shall be calculated
-                radiation = .FALSE.,       & !< flag parameter indicating whether the radiation model is used
-                sun_up    = .TRUE.,        & !< flag parameter indicating whether the sun is up or down
-                sw_radiation = .TRUE.        !< flag parameter indicing whether shortwave radiation shall be calculated
-
-    REAL(wp), PARAMETER :: sigma_sb       = 5.67E-8_wp, & !< Stefan-Boltzmann constant
-                           solar_constant = 1368.0_wp     !< solar constant at top of atmosphere
- 
-    REAL(wp) :: albedo = 9999999.9_wp,        & !< NAMELIST alpha
-                albedo_lw_dif = 9999999.9_wp, & !< NAMELIST aldif
-                albedo_lw_dir = 9999999.9_wp, & !< NAMELIST aldir
-                albedo_sw_dif = 9999999.9_wp, & !< NAMELIST asdif
-                albedo_sw_dir = 9999999.9_wp, & !< NAMELIST asdir
-                dt_radiation = 0.0_wp,        & !< radiation model timestep
-                emissivity = 0.95_wp,         & !< NAMELIST surface emissivity
-                exn,                          & !< Exner function
-                lon = 0.0_wp,                 & !< longitude in radians
-                lat = 0.0_wp,                 & !< latitude in radians
-                decl_1,                       & !< declination coef. 1
-                decl_2,                       & !< declination coef. 2
-                decl_3,                       & !< declination coef. 3
-                time_utc,                     & !< current time in UTC
-                time_utc_init = 43200.0_wp,   & !< UTC time at model start (noon)
-                lambda = 0.0_wp,              & !< longitude in degrees
-                net_radiation = 0.0_wp,       & !< net radiation at surface
-                time_radiation = 0.0_wp,      & !< time since last call of radiation code
-                sky_trans                       !< sky transmissivity
-
+    LOGICAL ::  constant_albedo = .FALSE.,       & !< flag parameter indicating whether the albedo may change depending on zenith
+                force_radiation_call = .FALSE.,  & !< flag parameter for unscheduled radiation calls
+                lw_radiation = .TRUE.,           & !< flag parameter indicing whether longwave radiation shall be calculated
+                radiation = .FALSE.,             & !< flag parameter indicating whether the radiation model is used
+                sun_up    = .TRUE.,              & !< flag parameter indicating whether the sun is up or down
+                sw_radiation = .TRUE.              !< flag parameter indicing whether shortwave radiation shall be calculated
+
+
+    REAL(wp), PARAMETER :: d_seconds_hour  = 0.000277777777778_wp,  & !< inverse of seconds per hour (1/3600)
+                           d_hours_day    = 0.0416666666667_wp,     & !< inverse of hours per day (1/24)
+                           sigma_sb       = 5.67037321E-8_wp,       & !< Stefan-Boltzmann constant
+                           solar_constant = 1368.0_wp                 !< solar constant at top of atmosphere
+
+    REAL(wp) :: albedo = 9999999.9_wp,           & !< NAMELIST alpha
+                albedo_lw_dif = 9999999.9_wp,    & !< NAMELIST aldif
+                albedo_lw_dir = 9999999.9_wp,    & !< NAMELIST aldir
+                albedo_sw_dif = 9999999.9_wp,    & !< NAMELIST asdif
+                albedo_sw_dir = 9999999.9_wp,    & !< NAMELIST asdir
+                decl_1,                          & !< declination coef. 1
+                decl_2,                          & !< declination coef. 2
+                decl_3,                          & !< declination coef. 3
+                dt_radiation = 0.0_wp,           & !< radiation model timestep
+                emissivity = 0.98_wp,            & !< NAMELIST surface emissivity
+                lambda = 0.0_wp,                 & !< longitude in degrees
+                lon = 0.0_wp,                    & !< longitude in radians
+                lat = 0.0_wp,                    & !< latitude in radians
+                net_radiation = 0.0_wp,          & !< net radiation at surface
+                skip_time_do_radiation = 0.0_wp, & !< Radiation model is not called before this time
+                sky_trans,                       & !< sky transmissivity
+                time_radiation = 0.0_wp,         & !< time since last call of radiation code
+                time_utc,                        & !< current time in UTC
+                time_utc_init = 43200.0_wp         !< UTC time at model start (noon)
 
     REAL(wp), DIMENSION(0:0) ::  zenith        !< solar zenith angle
@@ -213,12 +217,21 @@
 
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET :: &
+                        rad_lw_cs_hr,                  & !< longwave clear sky radiation heating rate (K/s)
+                        rad_lw_cs_hr_av,               & !< average of rad_lw_cs_hr
+                        rad_lw_hr,                     & !< longwave radiation heating rate (K/s)
+                        rad_lw_hr_av,                  & !< average of rad_sw_hr
+                        rad_lw_in,                     & !< incoming longwave radiation (W/m2)
+                        rad_lw_in_av,                  & !< average of rad_lw_in
+                        rad_lw_out,                    & !< outgoing longwave radiation (W/m2)
+                        rad_lw_out_av,                 & !< average of rad_lw_out
+                        rad_sw_cs_hr,                  & !< shortwave clear sky radiation heating rate (K/s)
+                        rad_sw_cs_hr_av,               & !< average of rad_sw_cs_hr
+                        rad_sw_hr,                     & !< shortwave radiation heating rate (K/s)
+                        rad_sw_hr_av,                  & !< average of rad_sw_hr
                         rad_sw_in,                     & !< incoming shortwave radiation (W/m2)
                         rad_sw_in_av,                  & !< average of rad_sw_in
                         rad_sw_out,                    & !< outgoing shortwave radiation (W/m2)
-                        rad_sw_out_av,                 & !< average of rad_sw_out
-                        rad_lw_in,                     & !< incoming longwave radiation (W/m2)
-                        rad_lw_in_av,                  & !< average of rad_lw_in
-                        rad_lw_out,                    & !< outgoing longwave radiation (W/m2)
-                        rad_lw_out_av                    !< average of rad_lw_out
+                        rad_sw_out_av                    !< average of rad_sw_out
+
 
 !
@@ -244,9 +257,9 @@
                     rrtm_icld = 0,     & !< cloud flag (0: clear sky column, 1: cloudy column)
                     rrtm_iaer = 0,     & !< aerosol option flag (0: no aerosol layers, for lw only: 6 (requires setting of rrtm_sw_ecaer), 10: one or more aerosol layers (not implemented)
-                    rrtm_idrv = 0        !< longwave upward flux calculation option (0,1)
+                    rrtm_idrv = 1        !< longwave upward flux calculation option (0,1)
 
     LOGICAL :: snd_exists = .FALSE.      !< flag parameter to check whether a user-defined input files exists
 
-    REAL(wp), PARAMETER :: mol_weight_air_d_wv = 1.607793_wp !< molecular weight dry air / water vapor
+    REAL(wp), PARAMETER :: mol_mass_air_d_wv = 1.607793_wp !< molecular weight dry air / water vapor
 
     REAL(wp), DIMENSION(:), ALLOCATABLE :: hyp_snd,     & !< hypostatic pressure from sounding data (hPa)
@@ -255,40 +268,42 @@
                                            t_snd          !< actual temperature from sounding data (hPa)
 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: aldif,         & !< longwave diffuse albedo solar angle of 60Â°
-                                             aldir,         & !< longwave direct albedo solar angle of 60Â°
-                                             asdif,         & !< shortwave diffuse albedo solar angle of 60Â°
-                                             asdir,         & !< shortwave direct albedo solar angle of 60Â°
-                                             rrtm_ccl4vmr,  & !< CCL4 volume mixing ratio (g/mol)
-                                             rrtm_cfc11vmr, & !< CFC11 volume mixing ratio (g/mol)
-                                             rrtm_cfc12vmr, & !< CFC12 volume mixing ratio (g/mol)
-                                             rrtm_cfc22vmr, & !< CFC22 volume mixing ratio (g/mol)
-                                             rrtm_ch4vmr,   & !< CH4 volume mixing ratio
-                                             rrtm_cicewp,   & !< in-cloud ice water path (g/mÂ²)
-                                             rrtm_cldfr,    & !< cloud fraction (0,1)
-                                             rrtm_cliqwp,   & !< in-cloud liquid water path (g/mÂ²)
-                                             rrtm_co2vmr,   & !< CO2 volume mixing ratio (g/mol)
-                                             rrtm_emis,     & !< surface emissivity (0-1)    
-                                             rrtm_h2ovmr,   & !< H2O volume mixing ratio
-                                             rrtm_n2ovmr,   & !< N2O volume mixing ratio
-                                             rrtm_o2vmr,    & !< O2 volume mixing ratio
-                                             rrtm_o3vmr,    & !< O3 volume mixing ratio
-                                             rrtm_play,     & !< pressure layers (hPa, zu-grid)
-                                             rrtm_plev,     & !< pressure layers (hPa, zw-grid)
-                                             rrtm_reice,    & !< cloud ice effective radius (microns)
-                                             rrtm_reliq,    & !< cloud water drop effective radius (microns)
-                                             rrtm_tlay,     & !< actual temperature (K, zu-grid)
-                                             rrtm_tlev,     & !< actual temperature (K, zw-grid)
-                                             rrtm_lwdflx,   & !< RRTM output of incoming longwave radiation flux (W/m2)
-                                             rrtm_lwuflx,   & !< RRTM output of outgoing longwave radiation flux (W/m2)
-                                             rrtm_lwhr,     & !< RRTM output of longwave radiation heating rate (K/d)
-                                             rrtm_lwuflxc,  & !< RRTM output of incoming clear sky longwave radiation flux (W/m2)
-                                             rrtm_lwdflxc,  & !< RRTM output of outgoing clear sky longwave radiation flux (W/m2) 
-                                             rrtm_lwhrc,    & !< RRTM output of incoming longwave clear sky radiation heating rate (K/d)
-                                             rrtm_swdflx,   & !< RRTM output of incoming shortwave radiation flux (W/m2)
-                                             rrtm_swuflx,   & !< RRTM output of outgoing shortwave radiation flux (W/m2)
-                                             rrtm_swhr,     & !< RRTM output of shortwave radiation heating rate (K/d)
-                                             rrtm_swuflxc,  & !< RRTM output of incoming clear sky shortwave radiation flux (W/m2)
-                                             rrtm_swdflxc,  & !< RRTM output of outgoing clear sky shortwave radiation flux (W/m2) 
-                                             rrtm_swhrc       !< RRTM output of incoming shortwave clear sky radiation heating rate (K/d) 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: aldif,          & !< longwave diffuse albedo solar angle of 60Â°
+                                             aldir,          & !< longwave direct albedo solar angle of 60Â°
+                                             asdif,          & !< shortwave diffuse albedo solar angle of 60Â°
+                                             asdir,          & !< shortwave direct albedo solar angle of 60Â°
+                                             rrtm_ccl4vmr,   & !< CCL4 volume mixing ratio (g/mol)
+                                             rrtm_cfc11vmr,  & !< CFC11 volume mixing ratio (g/mol)
+                                             rrtm_cfc12vmr,  & !< CFC12 volume mixing ratio (g/mol)
+                                             rrtm_cfc22vmr,  & !< CFC22 volume mixing ratio (g/mol)
+                                             rrtm_ch4vmr,    & !< CH4 volume mixing ratio
+                                             rrtm_cicewp,    & !< in-cloud ice water path (g/mÂ²)
+                                             rrtm_cldfr,     & !< cloud fraction (0,1)
+                                             rrtm_cliqwp,    & !< in-cloud liquid water path (g/mÂ²)
+                                             rrtm_co2vmr,    & !< CO2 volume mixing ratio (g/mol)
+                                             rrtm_emis,      & !< surface emissivity (0-1)    
+                                             rrtm_h2ovmr,    & !< H2O volume mixing ratio
+                                             rrtm_n2ovmr,    & !< N2O volume mixing ratio
+                                             rrtm_o2vmr,     & !< O2 volume mixing ratio
+                                             rrtm_o3vmr,     & !< O3 volume mixing ratio
+                                             rrtm_play,      & !< pressure layers (hPa, zu-grid)
+                                             rrtm_plev,      & !< pressure layers (hPa, zw-grid)
+                                             rrtm_reice,     & !< cloud ice effective radius (microns)
+                                             rrtm_reliq,     & !< cloud water drop effective radius (microns)
+                                             rrtm_tlay,      & !< actual temperature (K, zu-grid)
+                                             rrtm_tlev,      & !< actual temperature (K, zw-grid)
+                                             rrtm_lwdflx,    & !< RRTM output of incoming longwave radiation flux (W/m2)
+                                             rrtm_lwdflxc,   & !< RRTM output of outgoing clear sky longwave radiation flux (W/m2) 
+                                             rrtm_lwuflx,    & !< RRTM output of outgoing longwave radiation flux (W/m2)
+                                             rrtm_lwuflxc,   & !< RRTM output of incoming clear sky longwave radiation flux (W/m2)
+                                             rrtm_lwuflx_dt, & !< RRTM output of incoming clear sky longwave radiation flux (W/m2)
+                                             rrtm_lwuflxc_dt,& !< RRTM output of outgoing clear sky longwave radiation flux (W/m2)
+                                             rrtm_lwhr,      & !< RRTM output of longwave radiation heating rate (K/d)
+                                             rrtm_lwhrc,     & !< RRTM output of incoming longwave clear sky radiation heating rate (K/d)
+                                             rrtm_swdflx,    & !< RRTM output of incoming shortwave radiation flux (W/m2)
+                                             rrtm_swdflxc,   & !< RRTM output of outgoing clear sky shortwave radiation flux (W/m2) 
+                                             rrtm_swuflx,    & !< RRTM output of outgoing shortwave radiation flux (W/m2)
+                                             rrtm_swuflxc,   & !< RRTM output of incoming clear sky shortwave radiation flux (W/m2)
+                                             rrtm_swhr,      & !< RRTM output of shortwave radiation heating rate (K/d)
+                                             rrtm_swhrc        !< RRTM output of incoming shortwave clear sky radiation heating rate (K/d) 
 
 !
@@ -296,10 +311,6 @@
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  rad_lw_cs_in,   & !< incoming clear sky longwave radiation (W/m2) (not used)
                                                 rad_lw_cs_out,  & !< outgoing clear sky longwave radiation (W/m2) (not used)
-                                                rad_lw_cs_hr,   & !< longwave clear sky radiation heating rate (K/d) (not used)
-                                                rad_lw_hr,      & !< longwave radiation heating rate (K/d)
                                                 rad_sw_cs_in,   & !< incoming clear sky shortwave radiation (W/m2) (not used)
                                                 rad_sw_cs_out,  & !< outgoing clear sky shortwave radiation (W/m2) (not used)
-                                                rad_sw_cs_hr,   & !< shortwave clear sky radiation heating rate (K/d) (not used)
-                                                rad_sw_hr,      & !< shortwave radiation heating rate (K/d)
                                                 rrtm_aldif,     & !< surface albedo for longwave diffuse radiation
                                                 rrtm_aldir,     & !< surface albedo for longwave direct radiation
@@ -316,4 +327,5 @@
                                                 rrtm_sw_asmaer, & !< sw aerosol asymmetry parameter
                                                 rrtm_sw_ecaer     !< sw aerosol optical detph at 0.55 microns (rrtm_iaer = 6 only)
+
 #endif
 
@@ -341,13 +353,17 @@
     PUBLIC albedo, albedo_type, albedo_type_name, albedo_lw_dif, albedo_lw_dir,&
            albedo_sw_dif, albedo_sw_dir, constant_albedo, day_init, dots_rad,  &
-           dt_radiation, init_radiation, lambda, lw_radiation, net_radiation,  &
-           rad_net, rad_net_av, radiation, radiation_clearsky,                 &
-           radiation_rrtmg, radiation_scheme, radiation_tendency, rad_lw_in,   &
-           rad_lw_in_av, rad_lw_out, rad_lw_out_av, rad_sw_in, rad_sw_in_av,   &
-           rad_sw_out, rad_sw_out_av, sigma_sb, sw_radiation, time_radiation,  &
-           time_utc_init 
+           dt_radiation, emissivity, force_radiation_call, init_radiation,     &
+           lambda, lw_radiation, net_radiation, rad_net, rad_net_av, radiation,&
+           radiation_clearsky, radiation_rrtmg, radiation_scheme,              &
+           radiation_tendency, rad_lw_in, rad_lw_in_av, rad_lw_out,            &
+           rad_lw_out_av, rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr,            &
+           rad_lw_hr_av, rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av,   &
+           rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr, rad_sw_hr_av, sigma_sb,   &
+           skip_time_do_radiation, sw_radiation, time_radiation, time_utc_init
+
 
 #if defined ( __rrtmg )
-    PUBLIC rrtm_aldif, rrtm_aldir, rrtm_asdif, rrtm_asdir
+    PUBLIC rrtm_aldif, rrtm_aldir, rrtm_asdif, rrtm_asdir, rrtm_idrv,          &
+           rrtm_lwuflx_dt
 #endif
 
@@ -483,22 +499,16 @@
 !
 !--       Allocate 3d arrays of radiative fluxes and heating rates
-          ALLOCATE ( rad_sw_hr(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( rad_sw_cs_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( rad_sw_cs_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( rad_sw_cs_hr(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
-
           IF ( .NOT. ALLOCATED ( rad_sw_in ) )  THEN
              ALLOCATE ( rad_sw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              rad_sw_in = 0.0_wp
-
           ENDIF
 
           IF ( .NOT. ALLOCATED ( rad_sw_in_av ) )  THEN
              ALLOCATE ( rad_sw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-             rad_sw_out = 0.0_wp
           ENDIF
 
           IF ( .NOT. ALLOCATED ( rad_sw_out ) )  THEN
              ALLOCATE ( rad_sw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_sw_out = 0.0_wp
           ENDIF
 
@@ -507,8 +517,23 @@
           ENDIF
 
-          ALLOCATE ( rad_lw_hr(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( rad_lw_cs_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( rad_lw_cs_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( rad_lw_cs_hr(nzb+1:nzt+1,nysg:nyng,nxlg:nxrg) )
+          IF ( .NOT. ALLOCATED ( rad_sw_hr ) )  THEN
+             ALLOCATE ( rad_sw_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_sw_hr = 0.0_wp
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_sw_hr_av ) )  THEN
+             ALLOCATE ( rad_sw_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_sw_hr_av = 0.0_wp
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_sw_cs_hr ) )  THEN
+             ALLOCATE ( rad_sw_cs_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_sw_cs_hr = 0.0_wp
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_sw_cs_hr_av ) )  THEN
+             ALLOCATE ( rad_sw_cs_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_sw_cs_hr_av = 0.0_wp
+          ENDIF
 
           IF ( .NOT. ALLOCATED ( rad_lw_in ) )  THEN
@@ -530,13 +555,33 @@
           ENDIF
 
-          rad_sw_hr     = 0.0_wp
+          IF ( .NOT. ALLOCATED ( rad_lw_hr ) )  THEN
+             ALLOCATE ( rad_lw_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_lw_hr = 0.0_wp
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_lw_hr_av ) )  THEN
+             ALLOCATE ( rad_lw_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_lw_hr_av = 0.0_wp
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_lw_cs_hr ) )  THEN
+             ALLOCATE ( rad_lw_cs_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_lw_cs_hr = 0.0_wp
+          ENDIF
+
+          IF ( .NOT. ALLOCATED ( rad_lw_cs_hr_av ) )  THEN
+             ALLOCATE ( rad_lw_cs_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             rad_lw_cs_hr_av = 0.0_wp
+          ENDIF
+
+          ALLOCATE ( rad_sw_cs_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rad_sw_cs_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
           rad_sw_cs_in  = 0.0_wp
           rad_sw_cs_out = 0.0_wp
-          rad_sw_cs_hr  = 0.0_wp
-
-          rad_lw_hr     = 0.0_wp
+
+          ALLOCATE ( rad_lw_cs_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          ALLOCATE ( rad_lw_cs_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
           rad_lw_cs_in  = 0.0_wp
           rad_lw_cs_out = 0.0_wp
-          rad_lw_cs_hr  = 0.0_wp
 
 !
@@ -578,21 +623,23 @@
 !--    Add timeseries for radiation model
        dots_rad = dots_num + 1
-       dots_label(dots_num+1) = "rad_net"
-       dots_label(dots_num+2) = "rad_lw_in"
-       dots_label(dots_num+3) = "rad_lw_out"
-       dots_label(dots_num+4) = "rad_sw_in"
-       dots_label(dots_num+5) = "rad_sw_out"
-       dots_unit(dots_num+1:dots_num+5) = "W/m2"
-       dots_num  = dots_num + 5
+       dots_num = dots_num + 5
+
+       dots_label(dots_rad+1) = "rad_net"
+       dots_label(dots_rad+2) = "rad_lw_in"
+       dots_label(dots_rad+3) = "rad_lw_out"
+       dots_label(dots_rad+4) = "rad_sw_in"
+       dots_label(dots_rad+5) = "rad_sw_out"
+       dots_unit(dots_rad:dots_rad+4) = "W/m2"
 
 !
 !--    Output of albedos is only required for RRTMG
        IF ( radiation_scheme == 'rrtmg' )  THEN
-          dots_label(dots_num+1) = "rrtm_aldif"
-          dots_label(dots_num+2) = "rrtm_aldir"
-          dots_label(dots_num+3) = "rrtm_asdif"
-          dots_label(dots_num+4) = "rrtm_asdir"
-          dots_unit(dots_num+1:dots_num+4) = ""
           dots_num  = dots_num + 4
+          dots_label(dots_rad+5) = "rrtm_aldif"
+          dots_label(dots_rad+6) = "rrtm_aldir"
+          dots_label(dots_rad+7) = "rrtm_asdif"
+          dots_label(dots_rad+8) = "rrtm_asdir"
+          dots_unit(dots_num+5:dots_num+8) = ""
+
        ENDIF
 
@@ -624,5 +671,8 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) :: i, j, k
+       INTEGER(iwp) :: i, j, k   !< loop indices
+       REAL(wp)     :: exn,   &  !< Exner functions at surface
+                       exn_1, &  !< Exner functions at first grid level
+                       pt_1      !< potential temperature at first grid level
 
 !
@@ -643,10 +693,20 @@
           DO j = nys, nyn
              k = nzb_s_inner(j,i)
+
+             exn_1 = (hyp(k+1) / 100000.0_wp )**0.286_wp
+
              rad_sw_in(0,j,i)  = solar_constant * sky_trans * zenith(0)
              rad_sw_out(0,j,i) = alpha(j,i) * rad_sw_in(0,j,i)
-             rad_lw_out(0,j,i) = sigma_sb * (pt(k,j,i) * exn)**4
-             rad_lw_in(0,j,i)  = 0.8_wp * sigma_sb * (pt(k+1,j,i) * exn)**4
-             rad_net(j,i)      = rad_sw_in(0,j,i) - rad_sw_out(0,j,i)          &
-                                 + rad_lw_in(0,j,i) - rad_lw_out(0,j,i)
+             rad_lw_out(0,j,i) = emissivity * sigma_sb * (pt(k,j,i) * exn)**4
+
+             IF ( cloud_physics )  THEN
+                pt_1 = pt(k+1,j,i) + l_d_cp / exn_1 * ql(k+1,j,i)
+                rad_lw_in(0,j,i)  = 0.8_wp * sigma_sb * (pt_1 * exn_1)**4
+             ELSE
+                rad_lw_in(0,j,i)  = 0.8_wp * sigma_sb * (pt(k+1,j,i) * exn_1)**4
+             ENDIF
+
+             rad_net(j,i) = rad_sw_in(0,j,i) - rad_sw_out(0,j,i)               &
+                            + rad_lw_in(0,j,i) - rad_lw_out(0,j,i)
 
           ENDDO
@@ -682,8 +742,8 @@
 #if defined ( __rrtmg )
 
-       INTEGER(iwp) :: i, j, k, n          !< 
-
-       REAL(wp)     ::  s_r2      !< weighted sum over all droplets with r^2
-       REAL(wp)     ::  s_r3      !< weighted sum over all droplets with r^3
+       INTEGER(iwp) :: i, j, k, n !< loop indices
+
+       REAL(wp)     ::  s_r2, &   !< weighted sum over all droplets with r^2
+                        s_r3      !< weighted sum over all droplets with r^3
 
 !
@@ -703,5 +763,5 @@
 !--    profile. nzt_rad might be modified by these calls and all required arrays
 !--    will then be re-allocated
-       IF ( large_scale_forcing  .AND.  lsf_surf ) THEN
+       IF ( large_scale_forcing  .AND.  lsf_surf )  THEN
           CALL read_sounding_data
           CALL read_trace_gas_data
@@ -714,10 +774,11 @@
 !
 !--          Prepare profiles of temperature and H2O volume mixing ratio
-             rrtm_tlev(0,nzb+1) = pt(nzb,j,i)
+             rrtm_tlev(0,nzb+1) = pt(nzb,j,i) * ( surface_pressure             &
+                                                  / 1000.0_wp )**0.286_wp
 
              DO k = nzb+1, nzt+1
                 rrtm_tlay(0,k) = pt(k,j,i) * ( (hyp(k) ) / 100000.0_wp         &
-                                 )**0.286_wp + ( l_v / cp ) * ql(k,j,i)
-                rrtm_h2ovmr(0,k) = mol_weight_air_d_wv * (q(k,j,i) - ql(k,j,i))
+                                 )**0.286_wp + l_d_cp * ql(k,j,i)
+                rrtm_h2ovmr(0,k) = mol_mass_air_d_wv * (q(k,j,i) - ql(k,j,i))
 
              ENDDO
@@ -754,20 +815,23 @@
              rrtm_reliq  = 0.0_wp
              rrtm_cliqwp = 0.0_wp
+             rrtm_icld   = 0
 
              DO k = nzb+1, nzt+1
-                rrtm_cliqwp(0,k) =  ql(k,j,i) * 1000.0_wp *                      &
-                                  (rrtm_plev(0,k) - rrtm_plev(0,k+1)) * 100.0_wp / g 
-
-                IF ( rrtm_cliqwp(0,k) .GT. 0 )  THEN
+                rrtm_cliqwp(0,k) =  ql(k,j,i) * 1000.0_wp *                    &
+                                    (rrtm_plev(0,k) - rrtm_plev(0,k+1))        &
+                                    * 100.0_wp / g 
+
+                IF ( rrtm_cliqwp(0,k) > 0.0_wp )  THEN
                    rrtm_cldfr(0,k) = 1.0_wp
-                   rrtm_icld = 1
+                   IF ( rrtm_icld == 0 )  rrtm_icld = 1
 
 !
 !--                Calculate cloud droplet effective radius
                    IF ( cloud_physics )  THEN
-                      rrtm_reliq(0,k) = 1.0E6_wp * ( 3.0_wp * ql(k,j,i)          &
-                                      / ( 4.0_wp * pi * nc_const * rho_l )     &
-                                      )**0.33333333333333_wp                   &
-                                     * EXP( LOG( sigma_gc )**2 )
+                      rrtm_reliq(0,k) = 1.0E6_wp * ( 3.0_wp * ql(k,j,i)        &
+                                        * rho_surface                          &
+                                        / ( 4.0_wp * pi * nc_const * rho_l )   &
+                                        )**0.33333333333333_wp                 &
+                                        * EXP( LOG( sigma_gc )**2 )
 
                    ELSEIF ( cloud_droplets )  THEN
@@ -794,10 +858,8 @@
 !
 !--                Limit effective radius
-                   IF ( rrtm_reliq(0,k) .GT. 0.0_wp )  THEN
+                   IF ( rrtm_reliq(0,k) > 0.0_wp )  THEN
                       rrtm_reliq(0,k) = MAX(rrtm_reliq(0,k),2.5_wp)
                       rrtm_reliq(0,k) = MIN(rrtm_reliq(0,k),60.0_wp)
                   ENDIF
-                ELSE
-                   rrtm_icld = 0
                 ENDIF
              ENDDO
@@ -817,6 +879,9 @@
                rrtm_reliq      , rrtm_lw_tauaer,                               &
                rrtm_lwuflx     , rrtm_lwdflx  , rrtm_lwhr  ,                   &
-               rrtm_lwuflxc    , rrtm_lwdflxc , rrtm_lwhrc )
-
+               rrtm_lwuflxc    , rrtm_lwdflxc , rrtm_lwhrc ,                   &
+               rrtm_lwuflx_dt  ,  rrtm_lwuflxc_dt )
+
+!
+!--             Save fluxes
                 DO k = nzb, nzt+1
                    rad_lw_in(k,j,i)  = rrtm_lwdflx(0,k)
@@ -824,4 +889,10 @@
                 ENDDO
 
+!
+!--             Save heating rates (convert from K/d to K/h)
+                DO k = nzb+1, nzt+1
+                   rad_lw_hr(k,j,i)     = rrtm_lwhr(0,k)  * d_hours_day
+                   rad_lw_cs_hr(k,j,i)  = rrtm_lwhrc(0,k) * d_hours_day
+                ENDDO
 
              ENDIF
@@ -841,8 +912,18 @@
                rrtm_swuflxc    , rrtm_swdflxc , rrtm_swhrc )
   
+!
+!--             Save fluxes
                 DO k = nzb, nzt+1
                    rad_sw_in(k,j,i)  = rrtm_swdflx(0,k)
                    rad_sw_out(k,j,i) = rrtm_swuflx(0,k)
                 ENDDO
+
+!
+!--             Save heating rates (convert from K/d to K/s)
+                DO k = nzb+1, nzt+1
+                   rad_sw_hr(k,j,i)     = rrtm_swhr(0,k)  * d_hours_day
+                   rad_sw_cs_hr(k,j,i)  = rrtm_swhrc(0,k) * d_hours_day
+                ENDDO
+
              ENDIF
 
